#!/bin/bash

# rc.z_SCN.sh

# from GTK_button_color_.sh

export gcSysDevDob="230110-1612"

# ##^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ 
# System Developer ID name of this Linux BASH script
export gcSysDevId="SCN"
	
# ##^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

#~ PATH=$PATH:/usr/lib/gtkdialog/:/root/my-applications/bin/:
#~ /initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_GTK 
PATH=$PATH:/usr/lib/gtkdialog:/root/my-applications/bin/ 

if [ 0 -eq 1 ] ; then
	n=0
fi # end: if [ 0 -eq 1 ]


GTKDIALOG=gtkdialog

#######################################################################
#######################################################################
#######################################################################

#:######################################################################
function Scn_ReStart() {  #: ACTIVE
    n=0
    echo "(ft01) 0=:${0}: === EXIT=$EXIT ===:guiRESTART:=======read===" 
    echo ""
    read
    
    . ${0}
  

} # end: Scn_ReStart
export -f Scn_ReStart


#(: ======================================================================
#(: fx(Scn_SetVerDts)
#(: called by: Main ( )
#(: param: 
#(: purpose: 'gc' and 'Sys' System Standard Constants can be installed here.
#(: call this way:  Sbr_SetVerDts
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note: 
#(:
#:######################################################################
function Scn_SetVerDts() {  #: ACTIVE

### Manual Entry for  Developers Version  Date-Time-Stamp is above in "header" 

# ln(dummy)={x["''"]}
n=0    #: common "stub" so bare funxtion() will not fault during test/dev. 

# OK to wait until PUPSTATE is mounted/loaded, then assign most values in funxtion(Sys_PupState) . 
gcSysDvar=`date`
gcSysDts="`date +%y%m%d-%H%M-%S`"   
	# Sbr_SetVerDts
	# Note: grave-mark in date ( ) !!!
 
		lcNowDts="${lcNowDts:0:6}-${lcNowDts:6:7}"
		gcSysDtsNow="${lcNowDts}-local"

gcSysDtsNow="${lcNowDts}"
		#
		# ## common location of all "My_Dev" executable Editing Source Code
gcSys_MyDev="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_"


# ######################################################
#   "GTK_HEADER" related to DISTRO_SPECS and PUPSTATE
# ######################################################

. /etc/rc.d/PUPSTATE    # gather basic "state" of Puppy "system" 
. /etc/DISTRO_SPECS    # gather basic Distro data

#: ## === Signature === main ============================
# rc.sysinit Header
# PUPSTATE already loaded
# DISTRO_SPECS already loaded
export gcSysDistroName="${DISTRO_NAME}"
export gcSysDistroVersion="${DISTRO_VERSION}" 
export gcSysDistroPuppySFS="${DISTRO_PUPPYSFS}"
export gcSysDistro_Db_Subname="$DISTRO_DB_SUBNAME"		
export gcSysKernPup="`uname -r`"
export gcSysKernName="Kern:`uname -r`"


### Alternate Menu Selection
# export gcMgnConfigArbIdd=""	done in fx(Sbr_ARB_init)	

} #
# end: fx(Scn_SetVerDts)
# ######################################################################

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function Scn_EchoDateTime() {
    echo "$(date)"
} # end: fnEchoDatgeTime
export -f Scn_EchoDateTime


### build /tmp/gtkrc_color ##############################################
echo '
style "bgWhite" { bg[NORMAL] = "#FFFFFF" }
style "fgWhite" { fg[NORMAL] = "#FFFFFF" }
style "bgBlack" { bg[NORMAL] = "#000000" }

style "bgOrange" { bg[NORMAL] = "#EFAB24" }
style "fgOrange" { fg[NORMAL] = "#EFAB24" }

style "bgDrkRed" { bg[NORMAL] = "#EE5533" }
style "fgDrkRed" { fg[NORMAL] = "#EE5533" }

style "bgRed" { bg[NORMAL] = "#FF0000" }
style "fgRed" { fg[NORMAL] = "#FF0000" }
style "bgGreen" { bg[NORMAL] = "#FFFF00" }
style "fgGreen" { fg[NORMAL] = "#FFFF00" }
style "bgBlue" { bg[NORMAL] = "#0000FF" }
style "fgBlue" { fg[NORMAL] = "#0000FF" }

widget "MyWindowBg" style "bgDrkRed"
widget "MyWindowBg.GtkVBox.GtkHBox.MyButtonBg" style "bgGreen"

widget "MyWindowBg.GtkVBox.myEVB" style "bgBlue"

widget_class "*<GtkFrame>.GtkLabel" style "fgWhite"
widget_class "*<GtkFrame>.*.GtkLabel" style "fgGreen"
widget_class "*<GtkButton>.*.GtkLabel" style "fgRed"

' > /tmp/gtkrc_color
########################################################################

export GTK2_RC_FILES=/tmp/gtkrc_color

GTK_WIN_POS_NONE=0
GTK_WIN_POS_CENTER=1
GTK_WIN_POS_MOUSE=2

### source fn title
gcTitle="GTK_main"

### mainGUI ### "EOUI  DFEINITION" 
 
MAIN_DIALOG_FILE=${0}.gtkd   # whole 'XML' "mainGUI" is located in home subdir

cat <<-QwertyDefinition > ${MAIN_DIALOG_FILE}
 
<window 
    title="${gcTitle}"
    window-position="${GTK_WIN_POS_CENTER}"
    default-width="850"
    default-height="500"
    name="MyWindowBg"
> 
    <vbox>
        <eventbox name="myEVB" above-child="false" visible-window="true" width-request="333"  >
        <frame   Description  >
            <text><label>This is an example window.</label></text>
        </frame>
        </eventbox>
 
   		<vseparator height-request="77"> </vseparator>

        <hbox>

                <button has-focus="false" height-request="30"  
                    tooltip-text="Button Top C1" >
                    <label> "'---C1---'" </label>
                    <action>lxDummy:C1</action>
                </button>

			<text editable="false" use-markup="true" xalign="0">
				<label>"....X...." </label>  </text>

            <button name="MyButtonBg" use-underline="true" 
            tooltip-text="Refresh window variable - update date in window title">
                <label> _Refresh </label>
                <input file icon="gtk-refresh"></input>
                <width>16</width>
                <action function="refresh">vWindow</action>
            </button>

            <button has-focus="false" width-request="32" tooltip-text="Margin-C1" xalign=".5">
                <label> "" </label> <input file icon="gtk-select-color" ></input> <action>n=1</action>
            </button>
            <button has-focus="false" width-request="32" tooltip-text="Margin-C2" xalign=".5">
                <label> "     " </label> <action>n=2</action>
            </button>
			<text editable="false" use-markup="true" xalign="0">
				<label>"....X...." </label>  </text>

        </hbox>

        <hbox>
            <button visible="" use-stock="true" label="'ReStart'" has-focus="true" xalign="0"
                tooltip-text="Fall-Thru: ReStart program">
                <action>EXIT:guiRESTART</action>
            </button>
            <button visible="" use-stock="true" label="'Quit'" has-focus="true" xalign="1"
                tooltip-text="Fall-Thru: Quit program">
                <action>EXIT:guiQuit</action>
            </button>
        </hbox>

         <hbox>
                <button ok> </button>
                <button cancel> </button>
        </hbox>
 
    </vbox>

    <variable>vWindow</variable>
    <input>Scn_EchoDateTime</input>
    <action this-is-window="escape" signal="key-press-event" condition="command_is_true( [[ \$KEY_RAW = 0x9 ]] && echo true )">EXIT:exit</action>

</window>
QwertyDefinition

gtkdialog --center --file=${MAIN_DIALOG_FILE}

#~ rm -f ${MAIN_DIALOG_FILE}


    #~ # enables "ESC" to close window quick. 
    # vWindow is called by:                 <action function="refresh">vWindow</action>
    #~ <variable>vWindow</variable>
    #~ <input>Scn_EchoDateTime</input>
    #~ <action this-is-window="escape" signal="key-press-event" condition="command_is_true( [[ \$KEY_RAW = 0x9 ]] && echo true )">EXIT:exit</action>

#~ case ${1} in
    #~ -d | --dump) cat ${MAIN_DIALOG_FILE} ;;
    #~ *) gtkdialog --center --file=${MAIN_DIALOG_FILE} ;;
#~ esac

        #~ <hbox>
                #~ <button ok> </button>
                #~ <button cancel> </button>
        #~ </hbox>




#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
# ERRORMSG is used to show current ERROR param(1) 
# and is normally blank. 
# but generates empty space at top of display. 
GTK_Help_Box() {
	echo "$ERRORMSG
<b>${gcZeroRunX}</b>
<span foreground='"'red'"'><b>:Pupsave Backup: for 'frugal' installations</b></span> 
# <span foreground='"'blue'"'>makes a backup of the live pupsave file/folder,</span>
# <span foreground='"'green'"'>saves both 'save-Folder' and 'save-FILE.4fs' .</span>
#
# <span foreground='"'red'"'> <b>:program is run under 'nice -19' control:</b></span>
# to inhibit other programs from running 
#    during the 'BackUp' operations. 

# <span foreground='"'red'"'>BASH script: </span><span foreground='"'green'"'>
# reference stored /root/my-applications
# executable stored /root/my-applications/bin
# ReStart works on /root/my-applications/bin </span>

<b>1)</b> The date and time is automatically appended 
to the backup file name as "YYMMDD_SS".

<b>2)</b> For safest results, shut down all applications 
and servers before backing up.

<b>3)</b> <span foreground='"'green'"'>Program backs up system configuration (saveDATA) </span>
as it exists in the pupsave. <span foreground='"'red'"'>
It will not backup data stored outside the pupsave.</span>

To restore a backup, rename the file by removing the 
<b>.BKP-xxxx.xx.xx-xx.xx</b> file extension.

You must be running a frugal install (mode=13)
otherwise ${gcZeroRunX} will not run." > /tmp/box_help
	/usr/lib/gtkdialog/box_help "Pupsave Backup Help"
}
export -f GTK_Help_Box

#;;; FALL-THRU ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
# EXIT:guiWAIT
if [ "$EXIT" = "guiWAIT" ] ; then 
    n=0
    echo "(ft91) Gui ${EXIT} = guiWAIT :=======read===" 
    echo ""
    read
	GTK_ReStart
	# GTK_ReStart
	#~ cd -
fi # end: if [ "$EXIT" = "QUIT" ]

#;;; FALL-THRU ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#:######################################################################
#! function [EXIT:guiRESTART]
if [ "$EXIT" = "guiRESTART" ] ; then 
    n=0
    echo "(ft96) Gui ${EXIT} = guiRESTART :=======" 
    echo ""
    Scn_ReStart
    #~ cd -
fi # end: if [ "$EXIT" = "guiRESTART" ]

#;;; FALL-THRU ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
# EXIT:OK
if [ "$EXIT" = "OK" ] ; then 
    n=0
    echo "(ft97) Gui ${EXIT} = OK :=======" 
    echo ""
	#~ Scn_CleanUp
    exit 0
	#~ cd -
fi # end: if [ "$EXIT" = "QUIT" ]


#;;; FALL-THRU ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
if [ "$EXIT" = "" ] ; then  
    n=0
    echo "(ft98) Gui ${EXIT} = 'FAIL' :=======read===" 
    echo ""
    read
    exit 0
	#~ Scn_CleanUp
	#~ cd -
fi # end: if [ "$EXIT" = "QUIT" ]

    echo "(ft999) Absolute EXIT :=======" 
    echo ""


########################################################################
