#!/bin/bash
#    
#(: rc.z_pMNT.sh  calls pMOUNT to ALL Hard-Drive-List
#(:
#(: .sh format so GEANY sees a 'script' executable.
#(: chmod +x might be required for export files.
#
#(:   funxtion "Sys_MGN_pMount_All"  calls "Sys_pMount_sbr" 

# /initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_MNT/rc.z_MNT.sh
# /root/Startup/my_mount_drv.sh
# /initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_pMNT/rc.z_pMNT.sh
# /initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_uMNT/rc.z_uMNT.sh

# ##^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
# System Developer Initial DOB 
export gcSysDevDobPrev=""
export gcSysDevDob="221009-1723"		
# ##^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
# System Developer ID name of this Linux BASH script
export gcSysDevId="pMnt"	
# ##^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

n=0

EXIT="gui-P-MntInt"   # code taken from MGN.sh 

# fetch param #1
gcActiveGui=""

#(:======================================================================
#(: fx(Sys_pMount_sbr)	#: A
#(: called by:   ft(EXIT:guiPMntInt)  ( P Mnt Int )
#(: purpose:  pMOUNT  only one hard-drive
#(: receives param: "/mnt/sd?1"
#(: returns: 
#(: note: 
#(:    funxtion "Sys_pMount_All"  calls "Sys_pMount_sbr" 
#:######################################################################
function Sys_pMount_sbr() {   #: ACTIVE
 
    n=0
	sleep .3 
	lcMntAllLogP="${gcMntAllLogP}"

if [ "$gcActiveGui" = "1" ] ; then 
# -----------------------------------------------------------------------
/usr/lib/gtkdialog/box_splash -fg yellow -bg darkgreen -close never -text "\
.      Quick P-mount 
.       '${1}'                        "&
# ------------------------------------------------------------------------
    RETVAL=$?
	GTKPIDMAIN0=$!
fi

#~ echo "--------------------------------------------- " 
#~ echo ">>>>>>> Quick mkdir :'${1}':===" 
#~ echo " "

# MakeDrive if required for "P"mount. 
# mkdir param #1 is "/mnt/sda1", "/mnt/sdb1", "/mnt/sdc1", etc. 
mkdir -pv /mnt/${1} drv 

echo "---- ${lcMntAllLogP}   /dev/${1}  /mnt/${1}  " 

# log this trace ! > ${lcMntAllLogP} Continuous 

echo "=== P-MOUNT === again ===================================" >> ${lcMntAllLogP} 
# /mnt/home/my_mount_drv.log  
echo "${lcMntAllLogP}   /dev/${1}  /mnt/${1}  " >> ${lcMntAllLogP} 
# /mnt/home/my_mount_drv.log  

    # mount code --->
    # mount -t (type) 

    echo "First try: mount /mnt/${1} /mnt/${1} " 
    echo "First try: mount /mnt/${1} /mnt/${1} " >> ${lcMntAllLogP}  
    mount         /dev/${1} /mnt/${1} && echo "Success ==== ${1} ."  >> ${lcMntAllLogP} || echo "Fail."  >> ${lcMntAllLogP}

    echo "EXT3 try: mount /dev/${1} /mnt/${1}"  
    echo "EXT3 try: mount /dev/${1} /mnt/${1}"  >> ${lcMntAllLogP}
    mount -t ext3 /dev/${1} /mnt/${1} && echo "Success EXT3 ${1}."  >> ${lcMntAllLogP} || echo "Fail."  >> ${lcMntAllLogP}

    echo "VFAT try: mount /dev/${1} /mnt/${1}"  
    echo "VFAT try: mount /dev/${1} /mnt/${1}"  >> ${lcMntAllLogP}
    mount -t vfat /dev/${1} /mnt/${1} && echo "Success VFAT ${1}."  >> ${lcMntAllLogP} || echo "Fail."  >> ${lcMntAllLogP}

if [ "$gcActiveGui" = "1" ] ; then 
	sleep .3
    kill ${GTKPIDMAIN0}
fi

#(: called by:   ft(EXIT:gui-P-MntInt)  ( P Mnt Int )

}
# end: fx(Sys_pMount_sbr)


# ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
# ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
# ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



#(: ====================================================================
#(: ft(rc.z_pMNT.sh)
#(: called by: GUI button 	
#(: method: Fall-Thru and code is INTERNAL to MGN 
#(: param: 
#(: purpose: 
#(: calls: fx(Sys_pMount_sbr)
#(: method: calls internal script with lowercase HD names 
#(: sends: 
#(: rationale: 
#(: note : 
#(:
#(:
#
#:######################################################################
# begin:rc.z_pMNT (main)

n=0

#~ # fetch paramter #1
#~ lcActiveMntId="P"   # Id
#~ lcMntAllLogFn="/tmp/Mgn_MntAll${lcActiveMntId}.log"
#~ lcMntAllLog="${gcMntAllLog}${lcActiveMntId}" 
#~ lcGuiSbrName="guiUMntInt"

gcActiveGui="${1}"  # Gui="1"
gcMntAllLogP="/tmp/Mgn_MntAllP.log "
lcMntAllLogP="${gcMntAllLogP}" 
lcMntAllLogP="${gcMntAllLogP}" 
gcSysDvar=`date`
gcSysDts="`date +%y%m%d-%H%M-%S`"   

if [ "$gcActiveGui" = "1" ] ; then 
# ---1--------------------------------------------------------------------
/usr/lib/gtkdialog/box_splash -fg purple -bg lightgreen -close never -text "\
.              uMNT.sh 
.          :${lcMntAllLogP}: 
.
.
.
.
.                                                   "&
# ------------------------------------------------------------------------
    #
    RETVAL=$?
    GTKPIDMNT1=$!
    sleep .3
    #
fi 

#(: begin: open new log file
echo "*************************************************** "	> ${lcMntAllLogP}
echo "***** P-BEGIN ************** "	>> ${lcMntAllLogP}
echo "***  `date`  ***  ${lcMntAllLogP} "			>> ${lcMntAllLogP}
echo "*************************************************** "		>> ${lcMntAllLogP}
echo "***  " 	>> ${lcMntAllLogP}
#(: end: open new log file

#;;; never try to unmount /dev/sda1

#;;; repeat calls to fx(Sys_pMount_sbr) , which runs a single "Pmount" routine

#;;; begin looping internal code ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Sys_pMount_sbr "sda2" 
Sys_pMount_sbr "sdb1" 
Sys_pMount_sbr "sdc1" 
Sys_pMount_sbr "sdd1" 
Sys_pMount_sbr "sde1" 
Sys_pMount_sbr "sdf1" 
Sys_pMount_sbr "sdg1" 
Sys_pMount_sbr "sdh1" 
Sys_pMount_sbr "sdi1" 
Sys_pMount_sbr "sdj1" 
Sys_pMount_sbr "sdk1" 
#;;; end looping ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#(: if calling Sys_MGN_pMount internal, then must close log.file here. 
#(: begin: close the log file
#
echo " " >> ${lcMntAllLogP}
mount -l >> ${lcMntAllLogP}	# list code from 'mount' into log.file
#
echo "***" 	>> ${lcMntAllLogP}
echo "****** P-END **************" 	>> ${lcMntAllLogP}
echo "***  `date`  ***  ${lcMntAllLogP}" 		>> ${lcMntAllLogP}
echo "********************************************F*****" 	>> ${lcMntAllLogP}
#(: end: close the log file

    echo " " 
    echo "<<<<<<< Quick P-mnt Done ====="  
    echo " " 

if [ "$gcActiveGui" = "1" ] ; then 
    kill ${GTKPIDMAIN0}
fi
	#
if [ "$gcActiveGui" = "1" ] ; then 
# ---2--------------------------------------------------------------------
/usr/lib/gtkdialog/box_splash -fg yellow -bg red -close never -text "\
.              DONE  
.         fx(Sys_pMount_sbr)                            "&
# ------------------------------------------------------------------------
    RETVAL=$?
	GTKPIDMNT2=$!
	#
	sleep 3
    #
	kill ${GTKPIDMNT2}
	sleep 1
	kill ${GTKPIDMNT1}
    #
fi

# end: rc.z_uMNT (main)

#:### END ##############################################################
#:######################################################################
#:######################################################################
#:######################################################################
#:######################################################################



