#!/bin/bash
#   
#(: rc.z_uMNT.sh  calls uMOUNT to ALL Hard-Drive-List
#(:
#(: .sh format so GEANY sees a 'script' executable.
#(: chmod +x might be required for export files.
#
#(:   funxtion "Sys_MGN_uMount_All"  calls "Sys_MGN_uMount_sbr" 

# /initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_MNT/rc.z_MNT.sh
# /root/Startup/my_mount_drv.sh
# /initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_pMNT/rc.z_pMNT.sh
# /initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_uMNT/rc.z_uMNT.sh

# ##^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
# System Developer Initial DOB 
export gcSysDevDobPrev=""
export gcSysDevDob="220909-1723"
export gcSysDevDob="230110-0640"
# ##^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
# System Developer ID name of this Linux BASH script
export gcSysDevId="uMnt"	
# ##^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

n=0
set +x +e

# fetch param #1
gcActiveGui=""

#(:======================================================================
#(: fx(Sys_MGN_uMount_sbr)	#: A
#(: called by:   ft(EXIT:guiUMntInt)  ( U Mnt Int )
#(: purpose:  uMOUNT only one hard-drive
#(: receives param: "/mnt/sd?1"
#(: returns: 
#(: note: 
#(:    funxtion "Sys_MGN_uMount_All"  calls "Sys_MGN_uMount_sbr" 
#:######################################################################
function Sys_uMount_sbr() {  #: ACTIVE
	
    n=0
	sleep .3 
	lcMntAllLogU="${gcMntAllLogU}"

if [ "$gcActiveGui" = "1" ] ; then 
# -----------------------------------------------------------------------
/usr/lib/gtkdialog/box_splash -fg yellow -bg darkgreen -close never -text "\
.      Quick U-mount 
.       '${1}'                        "&
# ------------------------------------------------------------------------
    sleep .5
    RETVAL=$?
	GTKPIDMAIN0=$!
fi

#~ echo "--------------------------------------------- " 
#~ echo ">>>>>>> Quick U-mount ===== '${1}':" 
#~ echo " "

# MakeDrive if required. Not required for "U"mount. 
# mkdir param #1 is "sda1", etc. 
# mkdir -pv /mnt/${1} drv 
# needs a 'umount' control via "/mnt/sd?/"

# this is 'Umount' control 
echo "---- ${lcMntAllLogU} ${1}  " 

# continue log 
echo "=======================================" >> ${lcMntAllLogU} 
echo "${lcMntAllLogU}   ${1}  " >> ${lcMntAllLogU} 

# from Xenial 7.50 rc.shutdown 
# 01micko: umount is not a reliable script, so have to use umount-FULL
# also see shinobar's msg in http://murga-linux.com/puppy/viewtopic.php?p=605451#605451
# umount-FULL -a -t cifs,smbfs,nfs,sshfs

# if fail, then will "exit 0" from this sbr. 

	lcDirName="/root"	
	#: ### test if "real" mounted hard-drive 
    #: ### error will drop out 
	if [ -d ${lcDirName} ] ; then 
		lcMsgStr="=== ${lcDirName} /mnt/${1} ===" && echo "$lcMsgStr" 
		#========================
		umount -lv      /mnt/${1} 
		#========================
		lcMsgStr="=== Success ===" && echo "$lcMsgStr"  >> ${lcMntAllLogU}
		# code will un-mount via "/dev/", but not refresh screen to show this un-mount, 
		# refresh screen only with "/mnt/". 
	else
		# standard msg if beyond end of List of Hard-Drives. 
		lcMsgStr="=== Fail ===" && echo "$lcMsgStr" >> ${lcMntAllLogU}
		sleep .1
	fi		

if [ "$gcActiveGui" = "1" ] ; then 
    kill ${GTKPIDMAIN0}   	
fi
    # kill pid from this routine. 

# if fail, then will "exit 0" from this sbr. 

#(: called by:   ft(EXIT:guiUMntInt)  ( U Mnt Int )

} #
# end: fx(Sys_MGN_uMount_sbr)

# ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
# ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
# ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




#(: ============================================================
#(: ft(rc.z_uMNT.sh)
#(: called by: GUI button 	
#(: method: Fall-Thru and code is INTERNAL to MGN 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: calls internal script with lowercase HD names 
#(: sends: 
#(: rationale: 
#(: note : 
#(:
#(: calls Sys_MGN_uMount_sbr with internal prep.
#(: ? still calls "rc.z_MNT.sh"  external. 
#(:
#

#:######################################################################
# begin:rc.z_uMNT (main)

n=0

EXIT="gui-U-MntInt"   # code taken from MGN.sh 


#~ # fetch paramter #1
#~ lcActiveMntId="P"   # Id
#~ lcMntAllLogFn="/tmp/Mgn_MntAll${lcActiveMntId}.log"
#~ lcMntAllLog="${gcMntAllLog}${lcActiveMntId}" 
#~ lcGuiSbrName="guiUMntInt"

# fetch paramter #1
gcActiveGui="${1}"  # Gui="1"
gcMntAllLogU="/tmp/Mgn_MntAllU.log "
lcMntAllLogU="${gcMntAllLogU}" 
lcMntAllLogU="${gcMntAllLogU}" 
gcSysDvar=`date`
gcSysDts="`date +%y%m%d-%H%M-%S`"   

if [ "$gcActiveGui" = "1" ] ; then 
# ---1--------------------------------------------------------------------
/usr/lib/gtkdialog/box_splash -fg purple -bg lightgreen -close never -text "\
.              uMNT.sh 
.          :${lcMntAllLogU}: 
..
.
.
.
.                                                   "&
# ------------------------------------------------------------------------
    RETVAL=$?
	GTKPIDUMNT1=$!
    #
fi

#(: begin open log file
echo "********************************************************** " 	> ${lcMntAllLogU}
echo "****** U-BEGIN ************************** " 	>> ${lcMntAllLogU}
echo "***  `date`  *** ${lcMntAllLogU} " 			>> ${lcMntAllLogU}
echo "********************************************************** " 	>> ${lcMntAllLogU}
echo "***  " 	>> ${lcMntAllLogU}
#(: end: open log file

#;;; repeat calls to rc.z_MNT.sh, which runs a single "mount" routine

sleep .3

#;;; never try to unmount /dev/sda1

#;;; repeat calls to fx(Sys_MGN_pMount_sbr) , which runs a single "Umount" routine

#;;; begin looping subroutine umount process ;;;;;;;;;;;;;;;;;;;
Sys_uMount_sbr "sda2" 
Sys_uMount_sbr "sdb1" 
Sys_uMount_sbr "sdc1" 
Sys_uMount_sbr "sdd1" 
Sys_uMount_sbr "sde1" 
Sys_uMount_sbr "sdf1" 
Sys_uMount_sbr "sdg1" 
Sys_uMount_sbr "sdh1" 
Sys_uMount_sbr "sdi1" 
Sys_uMount_sbr "sdj1" 
Sys_uMount_sbr "sdk1" 
#;;; end looping ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#(: if calling Sys_MGN_pMount internal, then must close log.file here. 
#(: begin: close the log file
#
echo " " >> ${lcMntAllLogU}
mount -l >> ${lcMntAllLogU}	# list code from 'mount' into log.file
#
echo "***" 	>> ${lcMntAllLogU}
echo "****** U-END **************" 	>> ${lcMntAllLogU}
echo "***  `date`  ***  ${lcMntAllLog}${gcMntAllId}" 		>> ${lcMntAllLogU}
echo "*************************************************" 	>> ${lcMntAllLogU}
#
#(: end: close the log file

    #~ echo " " 
    #~ echo "<<<<<<< Quick U-mnt Done ====="  
    #~ echo " " 


if [ "$gcActiveGui" = "1" ] ; then 
        kill ${GTKPIDMAIN0}   
        # error is non-fatal, std for GTK dialog 	
# ---2--------------------------------------------------------------------
/usr/lib/gtkdialog/box_splash -fg yellow -bg red -close never -text "\
.       DONE  fx(guiPMntInt)       
.        Sys_MGN_uMount_sbr)                           "&
# ------------------------------------------------------------------------
    RETVAL=$?
	GTKPIDUMNT2=$!
 
	sleep 3
    #
	kill ${GTKPIDUMNT2}
	sleep .3
	kill ${GTKPIDUMNT1}
    #
fi
# end:rc.z_uMNT (main)

#:### END ##############################################################
#:######################################################################
#:######################################################################
#:######################################################################
#:######################################################################

