#!/bin/bash
#
### rc.z_RWB.sh
### from Ruf-Woof-Backup.sh
### RWB.sh


export gcSysDevDob="221112-0919"

# 
#~ if [ $# -lt 1 ] ; then
  #~ echo "rsync wrapper so that there is a new snapshot tarball"
  #~ echo "created per every run. Unmodified files are hard-linked"
  #~ echo "to previous backup"
  #~ echo
  #~ echo "Usage:"
  #~ echo "  $0 <source>"
  #~ echo
  #~ echo "Where:"
  #~ echo "  source        - the directory to be backed up as accepted by rsync"
  #~ echo "                  (local or remote)"
  #~ exit
#~ fi


TMPFILE=$(mktemp) || exit 1

src=$1  # not here
dst=$PWD # not here

srcID="UpupJJ_SRW_"
srcFn="/mnt/home/pup_UpupJJ-sda/upupjj+dsave-ram"
dst="/mnt/home/pup_UpupJJ-sda"

for p in $( rsync $dst/ | grep -oE '[0-9]{4}(\.[0-9]{2}){2}_[0-9]{2}(\.[0-9]{2}){2}' | tail -5 ) ; do
  linkPrev="--link-dest=../$p $linkPrev"
done

#~ if [ "$OS" = "Windows_NT" ] ; then
  #~ fixperm='--chmod=ug=rwX --chmod=o=rX'
#~ fi

d="$srcID"$( date +'%Y.%m.%d_%H.%M.%S' )
echo "Scanning files/folders"
rsync -av -i $linkPrev $fixperm "$srcFn/" "$dst/$d" | grep '^>' | awk -v srcFn="$srcFn/" '{ first = $1; $1 = "";gsub("^ ","");print src$0 }' | tee $TMPFILE || exit 1

if [ -s $TMPFILE ]; then # file has some data ?
	echo "Preparing tar file"
	{ tar -c -T $TMPFILE -f tar.tar ; } 2>/dev/null
else
	echo "No changes found, not creating tar file"
fi

# remove older backup folders
mv ${dst}/${d} abc123
ls | grep -oE '[0-9]{4}(\.[0-9]{2}){2}_[0-9]{2}(\.[0-9]{2}){2}' >$TMPFILE
cat $TMPFILE | xargs rm -rf
mv abc123 ${dst}/${d}
rm $TMPFILE

#~ # Set tar file to a timestamp type format, but not one that might
#~ # conflict (be picked up) as a rsync folder
d="srcID"$( date +'%a_%d_%b_%Y_%M:%H' )
if [ -f ${dst}/tar.tar ]; then 
	mv ${dst}/tar.tar ${dst}/tarfile_$d.tar 
fi

###
