#!/bin/sh
#
# rc.z_SFB.sh 
#
### "<S>ave<F>older<B>ackup,author-rcrsn51"  from Murga

#################################################
# 220321-0730 
# SaveFolderBackup original #  2017-04-01
# req: gtkdialog3
# req: lzop compression package for Compression & Restoration. 
# req: SFB script for Extract/Restore of lzop.sfb. 
# It is Possible to duplicate/write-over a previous lzop.sfb.

#################################################
# LZOP package is REQUIRED. 
# lzop --help
# BusyBox v1.35.0 (2022-05-11 12:27:11 +08) multi-call binary.
# Usage: lzop [-cfUvd123456789CF] [FILE]...
# -1..9	Compression level
# -d	Decompress
# -c	Write to stdout
# -f	Force
# -U	Delete input files
# -v	Verbose
# -F	Don't store or verify checksum
# -C	Also write checksum of compressed block

#################################################

export gcGtkDialog="1"   # gae

export gcSysDevDob="221003-1730"

export TEXTDOMAIN=SaveFolderBackup
export OUTPUT_CHARSET=UTF-8

export LZOPARG="-3" # Dependency is lzop compression package. SFB will compress/restore with lzop, no choice. 

export gcSysTitle="<S>ave<F>older<B>ackup,rcrsn51+gae" 


#(:;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function BACKUP ()
{   # called from GUI 
	[ ! -e "$SrcSelect" ] && Xdialog --title " " --msgbox "$(gettext 'Save folder not found!')" 0 0 && exit
	[ ! -d "$TrgSelect" ] && Xdialog --title " " --msgbox "$(gettext 'Location not found!')" 0 0 && exit
	Xdialog --no-buttons --title "${gcSysTitle}_Backup Xdialog " --infobox "$(gettext 'Working ...')" 0 0 600000 &
	MSGPID=$!

# working gae
# working change to simple TarOpt ala CTB 
    # -O  is to StdOut
    # -C  is change to directory DIR 
	tar -c -O -C "$(dirname "$SrcSelect")" "$(basename "$SrcSelect")" | lzop $LZOPARG -c > "$TrgSelect/$(basename "$SrcSelect").$(date +%F).sfb"

#~ tar -c -z -f "$(dirname "$SrcSelect")" "$(basename "$SrcSelect")" 

	#~ tar -c -O -C "$(dirname "$SrcSelect")" "$(basename "$SrcSelect")" | gzip  > "$TrgSelect/$(basename "$SrcSelect").$(date +%F).sfb"
	#~ tar -c -z -O -C "$(dirname "$SrcSelect")" "$(basename "$SrcSelect")"  > "$TrgSelect/$(basename "$SrcSelect").$(date +%F).sfb"
	#~ tar -c -z  -f /mnt/home/pup_UpupJJ-sda/upupjj+dsave-ram  /mnt/home/pup_UpupJJ-sda
    # extract via "pExtract" 

# working gae
#~ TAROPT="-c -z " #--checkpoint=1000" 
#~ tar -c -z -f "$TrgSelect/$(basename "$SrcSelect").$(date +%F).sfb"
#~ tar -c -O -C "$(dirname "$SrcSelect")" "$(basename "$SrcSelect")" | gzip  > "$TrgSelect/$(basename "$SrcSelect").$(date +%F).sfb"

# working gae
# from CTB.sh
#	TAROPT="-c -z --checkpoint=1000" 
#	tar ${TAROPT} -f ${lcTarOptSaveNameTrg} ${lcTarOptSaveNameSrc}.$(date +%F).sfb"


	sync
	kill $MSGPID
	Xdialog --title " " --msgbox "$(gettext 'Done.')" 0 0
} # end: fx(BACKUP)
export -f BACKUP

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function RESTORE ()
{
	[ ! -f "$SOURCE2" ] && Xdialog --title " " --msgbox "$(gettext 'Image file not found!')" 0 0 && exit
	[ ! -d "$DESTINATION2" ] && Xdialog --title " " --msgbox "$(gettext 'Location not found!')" 0 0 && exit
	Xdialog --no-buttons --title " " --infobox "$(gettext 'Working ...')" 0 0 600000 &
	MSGPID=$!
	lzop -d -c "$SOURCE2" | tar -x -C "$DESTINATION2"
	sync
	kill $MSGPID
	Xdialog --title " " --msgbox "$(gettext 'Done.')" 0 0
} # end: fx(RESTORE)
export -f RESTORE

################

export DIALOG="
<window title=\"${gcSysTitle}\">
<vbox>
<notebook labels=\"$(gettext 'Scan|Restore')\">
	<vbox>

		<frame>
			<text xalign=\"0\"><label>$(gettext 'Select:')</label></text>
			<text xalign=\"0\"><label>$(gettext 'The save folder will be compressed into a')</label></text>
			<text xalign=\"0\"><label>$(gettext 'single backup image file.')</label></text>
			<text xalign=\"0\"><label>$(gettext 'Do NOT back up a save folder while it is in use.')</label></text>
		</frame>

		<frame $(gettext 'Source-Select')>
			<hbox>
				<entry accept=\"directory\">
					<variable>SrcSelect</variable>
			 	</entry>
				<button>
					<input file stock=\"gtk-open\"></input>
					<action type=\"fileselect\">SrcSelect</action>
				</button>
				<button>
					<input file stock=\"gtk-clear\"></input>
					<action>Clear:SrcSelect</action>
				</button>
			</hbox>
		</frame>




		<frame $(gettext 'Target-Select:  the location to store the backup image file')>
			<hbox>
				<entry accept=\"directory\">
					<variable>TrgSelect</variable>
			 	</entry>
				<button>
						<input file stock=\"gtk-open\"></input>
						<action type=\"fileselect\">TrgSelect</action>
				</button>
				<button>
					<input file stock=\"gtk-clear\"></input>
					<action>Clear:TrgSelect</action>
				</button>
			</hbox>
		</frame>
		<hbox>
			<button>
				<label>$(gettext '{-Action-Backup-}')</label>
				<action>BACKUP &</action>
			</button>
		</hbox>
		<text><label>\"    \"</label></text>
	</vbox>

	<vbox>
		<frame>
			<text xalign=\"0\"><label>$(gettext 'RESTORE:')</label></text>
			<text xalign=\"0\"><label>$(gettext 'SFB is dependent on the LZOP package for Compression/Restoration.')</label></text>
			<text xalign=\"0\"><label>$(gettext 'You must delete the current save folder')</label></text>
			<text xalign=\"0\"><label>$(gettext '...before restoring the backup copy.')</label></text>
			<text xalign=\"0\"><label>$(gettext '...else you will overwrite a previous save.')</label></text>
			<text xalign=\"0\"><label>$(gettext 'Do NOT restore a save folder while it is in use.')</label></text>
		</frame>
		<frame $(gettext 'Select the location to restore the save folder')>
			<hbox>
				<entry accept=\"directory\">
					<variable>DESTINATION2</variable>
			 	</entry>
				<button>
					<input file stock=\"gtk-open\"></input>
					<action type=\"fileselect\">DESTINATION2</action>
				</button>
				<button>
       		<input file stock=\"gtk-clear\"></input>
       		<action>Clear:DESTINATION2</action>
      	</button>
			</hbox>
		</frame>
		<hbox>
			<button>
				<label>$(gettext 'Restore')</label>
				<action>RESTORE &</action>
			</button>
		</hbox>
		<text><label>\"    \"</label></text>
	</vbox>
</notebook>
<hbox>
	<button>
		<label>$(gettext 'Help')</label>
		<action>defaulthtmlviewer http://murga-linux.com/puppy/viewtopic.php?p=950010#950010 &</action>
	</button>
	<button>
		<label>$(gettext 'Abort')</label>
		<action>killall tar lzop</action>
	</button>
	<button><label>$(gettext 'Quit')</label></button>
</hbox>
</vbox>
</window>"

gtkdialog3 -G +600+50 -p DIALOG

#(: button "Quit" simply falls out !

#########################################
